Subject: Re: [PATCH] Celleb: improve htab lock

From: Benjamin Herrenschmidt <[email-masked]>
Date: Fri, 09 Feb 2007 09:30:08 +1100

> But I think the issue here is that we don't want to disable irqs because
> we want to protect against IRQ context, but rather because the
> hypervisor expects it.

No not really. The problem here is that we get a spinlock re-entrancy if
we don't disable IRQs so it's a typical textbook usage of
spin_lock_irqsave.

The problem is that if you don't disable IRQs, you can take an irq or a
decrementer exception causing some code to hit vmalloc or ioremap space
which might cause a hash fault, thus you may deadlock on the spinlock
via htab_insert.

Ben.